﻿''' <summary>
''' 拡張ラベル。
''' </summary>
''' <remarks></remarks>
Partial Public Class Label
    Inherits System.Web.UI.UserControl

    ''' <summary>
    ''' テキスト
    ''' </summary>
    ''' <remarks></remarks>
    Private mText As String = ""

    ''' <summary>
    ''' テキスト
    ''' </summary>
    ''' <value>テキスト</value>
    ''' <returns>テキスト</returns>
    ''' <remarks></remarks>
    Public Property Text() As String
        Get
            Return mText
        End Get
        Set(ByVal value As String)

            ' テキストを設定する
            mText = value
            ' ラベル値をコピーする
            copyOuterToInner()
        End Set
    End Property

    ''' <summary>
    ''' サニタイズ
    ''' </summary>
    ''' <remarks></remarks>
    Private mSanitize As Boolean = False

    ''' <summary>
    ''' サニタイズ
    ''' Html特殊文字をエスケープするかどうかのフラグ。
    ''' </summary>
    ''' <value>サニタイズフラグ</value>
    ''' <returns>サニタイズフラグ</returns>
    ''' <remarks></remarks>
    Public Property Sanitize() As Boolean
        Get
            Return mSanitize
        End Get
        Set(ByVal value As Boolean)
            mSanitize = value
        End Set
    End Property

    ''' <summary>
    ''' フォーマット
    ''' </summary>
    ''' <remarks></remarks>
    Private mFormat As String = ""

    ''' <summary>
    ''' フォーマット
    ''' </summary>
    ''' <value>フォーマット</value>
    ''' <returns>フォーマット</returns>
    ''' <remarks></remarks>
    Public Property Format() As String
        Get
            Return mFormat
        End Get
        Set(ByVal value As String)

            ' フォーマットを設定する
            mFormat = value
        End Set
    End Property

    ''' <summary>
    ''' 外部のラベル値を内部のラベルにコピーする。
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub copyOuterToInner()

        ' ビューステートに保存する
        storeViewState(mText)

        If mSanitize Then

            lblText.Text = HttpUtility.HtmlEncode(mText)
        Else

            lblText.Text = mText
        End If

        If mFormat IsNot Nothing AndAlso _
           mFormat <> "" Then

            lblText.Text = String.Format(mFormat, lblText.Text)
        End If

    End Sub

    ''' <summary>
    ''' ビューステートに値を保存する
    ''' </summary>
    ''' <param name="text"></param>
    ''' <remarks></remarks>
    Private Sub storeViewState(ByVal text As String)

        ViewState(Me.ClientID) = mText
    End Sub

    ''' <summary>
    ''' ビューステートから値をロードする
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub restoreViewState()

        If ViewState(Me.ClientID) IsNot Nothing Then
            mText = ViewState(Me.ClientID).ToString
            copyOuterToInner()
        End If

    End Sub

    ''' <summary>
    ''' ページロード時
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If Not IsPostBack Then

            ' ページロード
            copyOuterToInner()
        Else
            ' ポストバック
            restoreViewState()

        End If

    End Sub

End Class