﻿Public Partial Class item
    Inherits BasePage

    Private Const IMAGE_VIEW_URL As String = "~/contents/view/itemImage.aspx"

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Protected Sub cmdSearch_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdSearch.Click

        ' 画像のロード
        ' 画像の保存
        ' 商品の表示
        ' 商品のページング

        Dim item As New entity.Item

        item.DBAccessor = dbAccessor
        item.Id = Util.convertToNullableLong(Me.txtId.Text)

        If item.ExecSelect() > 0 Then

            Me.txtName.Text = item.ItemName
            Me.txtPrice.Text = CStr(item.Price)
            Me.fileImageView.ImageUrl = IMAGE_VIEW_URL & "?itemId=" & item.Id

        Else

            lblMessage.Text = "データが見つかりませんでした。"

            Me.txtName.Text = ""
            Me.txtPrice.Text = ""
            Me.fileImageView.ImageUrl = IMAGE_VIEW_URL & "?itemId=" & item.Id

        End If

    End Sub

    Protected Sub cmdSave_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdSave.Click

        Dim isRegisted As Boolean = False

        Dim item As New entity.Item

        Dim retCnt As Long = 0

        item.DBAccessor = dbAccessor
        item.Id = Util.convertToNullableLong(Me.txtId.Text)

        ' ファイルを読み込む
        Dim fileBinary() As Byte = Nothing
        Dim file As System.IO.Stream = fileImage.PostedFile.InputStream

        If file IsNot Nothing Then

            ' ファイルを読み込む
            fileBinary = readFile(file)
        End If

        If item.ExecSelect() > 0 Then

            item.ItemName = Me.txtName.Text
            item.Price = CLng(Me.txtPrice.Text)
            item.Image = fileBinary
            item.UpdateDate = Now
            item.UpdateUserId = "1"
            item.Version = item.Version + 1
            retCnt = item.ExecUpdateNullValueIgnore()

        Else

            item.ItemName = Me.txtName.Text
            item.Price = CLng(Me.txtPrice.Text)
            item.Image = fileBinary
            item.RegistDate = Now
            item.RegistUserId = "1"
            item.UpdateDate = Now
            item.UpdateUserId = "1"
            item.Version = 1
            retCnt = item.ExecInsert()

        End If

        If retCnt > 0 Then

            lblMessage.Text = "データが保存されました。"
        Else

            lblMessage.Text = "データが見つかりませんでした。"
        End If

    End Sub

    Protected Sub cmdDelete_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdDelete.Click

        Dim item As New entity.Item

        Dim retCnt As Long = 0

        item.DBAccessor = dbAccessor
        item.Id = Util.convertToNullableLong(Me.txtId.Text)

        retCnt = item.ExecDelete()

        If retCnt > 0 Then

            lblMessage.Text = "データが削除されました。"
        Else

            lblMessage.Text = "データが見つかりませんでした。"
        End If

    End Sub

    Private Function readFile(ByVal s As System.IO.Stream) As Byte()

        Try

            Dim streamLen As Integer = CInt(s.Length)

            Dim ret(streamLen) As Byte

            Dim numBytesRead As Integer = 0

            Dim n As Integer

            While numBytesRead < streamLen

                n = s.Read(ret, numBytesRead, 1000)

                If n = 0 Then

                    Exit While
                End If

                numBytesRead += n

            End While

            If ret.Length = 1 AndAlso ret(0) = 0 Then

                ret = Nothing
            End If

            Return ret

        Finally

            s.Close()

        End Try

    End Function

End Class